﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Media;

namespace MindFusion.Diagramming.Wpf.Samples.CS.Tutorial4
{
	public class EntityNode : TemplatedNode
	{
		static EntityNode()
		{
			DefaultStyleKeyProperty.OverrideMetadata(
				typeof(EntityNode), new FrameworkPropertyMetadata(typeof(EntityNode)));
		}

		public EntityNode()
		{
			
		}

		// Required for creating nodes by dragging them from the NodeListView
		public EntityNode(EntityNode prototype) : base(prototype)
		{
			Title = prototype.Title;
		}


		public string Title
		{
			get { return (string)GetValue(TitleProperty); }
			set { SetValue(TitleProperty, value); }
		}

		public Table Table
		{ get; set; }

		public static readonly DependencyProperty TitleProperty = DependencyProperty.Register(
			"Title",
			typeof(string),
			typeof(EntityNode),
			new PropertyMetadata(""));
	}

	public class Table
	{
		public string Name
		{ get; set; }
		public List<Column> Columns
		{ get; set; }

		public Table()
		{
			this.Columns = new List<Column>();
		}
	}

	public class Column
	{
		public string Keys
		{ get; set; }
		public string Name
		{ get; set; }
		public string DataTypeString
		{ get; set; }
	}
}
